﻿var hCheckingTimer, signature, imgTagsSet, nrImages, nrImagesRetrieved, nrLabelimagesRetrieved, nrScriptsRetrieved, colorCoding, nrColScalesRetrieved;
var h, img, n = 0, nmax = 3600, imgWidth = 120;
var server = "www.udeuschle.de";
//var server = "192.168.178.29";
var XMLHTTPObj = getXMLHTTP();

window.onunload = finish;

function startCheckingFinishedPans() {
    var text1, text2;
  if (lg == "en") {
      text1 = "Just a second";
      text2 = "Cancel";
  } else {
    if (lg == "it") {
        text1 = "Presto essa continuerà";
        text2 = "Cancellare";
    } else {
        text1 = "Gleich geht es weiter";
        text2 = "Abbrechen";
    }
  }

  $get("loadingMessage").innerHTML = "<img id='imgmsg' /><span id='loadingStatus' style='padding:0 5px'><br />" + text1 + "</span>";
  $get("loadingMessage").innerHTML += "<br /><br /><span id='loadingCancel'><a href='javascript:void(0);' onclick='javascript:finish();'>" + text2 + "</a></span>";
    
    img = $get("imgmsg");
    img.src = "images/ajax-loader_00.gif";
    img.alt = "";
    $get("loadingMessage").style.display = "inline";
    imgTagsSet = false;
    nrImagesRetrieved = 0;
    nrLabelimagesRetrieved = 0;
    nrScriptsRetrieved = 0;
    nrColScalesRetrieved = 0;
    if (lg == "en") {
      document.getElementById("getmgl").innerHTML = "Telescope 10x";
      document.getElementById("hlpmgl").innerHTML = "Get telescope frame: Click here or drag mouse in the panorama<br /><br />Move magnifying glass frame: Click into frame and drag it with left mouse button pressed<br /><br />Get magnified selection: Click into the ok button in the lower right corner of the frame<br /><br />Remove magnifying glass frame: Click on the white cross in upper right corner of the frame";
      document.getElementById("gethlp").innerHTML = "Help";
      document.getElementById("getcond").innerHTML = "Terms of use";
      document.getElementById("getprivacy").innerHTML = "Privacy policy";
      document.getElementById("spanActionInfo").innerHTML = "Move the mouse over the panorama.<br />Click on labels, profile lines, title or wherever the mouse cursor turns into crosshair.<br />";
      document.getElementById("spanOnClick").innerHTML = "On mouse click jump to:";
      document.getElementById("cond").innerHTML = "You may use this panorama freely for private purposes. Commercial use without my written consent is not allowed.<br />Any liabilities for damages undergone by using this panorama are excluded.";
      document.getElementById("aleGE").innerHTML = "Go to Google Earth window";
    } else {
      if (lg == "it") {
        document.getElementById("getmgl").innerHTML = "Binocolo 10x";
        document.getElementById("hlpmgl").innerHTML = "Get cornice binocolo: Clicca qui o trascinare il mouse in panorama<br /><br />Move cornice binocolo: Cliccare su telaio e trascinare con il tasto sinistro del mouse premuto<br /><br />Get ingrandita selezione: Fai clic su OK nell'angolo inferiore destro del cornice<br /><br />Rimuovere il cornice binocolo: Clicca sulla croce bianca in alto a destra della cornice";
        document.getElementById("gethlp").innerHTML = "Aiuto";
        document.getElementById("getcond").innerHTML = "Condizioni d'uso";
        document.getElementById("getprivacy").innerHTML = "Privacy policy";
        document.getElementById("spanActionInfo").innerHTML = "Muovi il mouse sopra il panorama.<br />Clicca sulle etichette, le linee di profilo, il titolo o dove il cursore del mouse si trasforma in croce.<br />";
        document.getElementById("spanOnClick").innerHTML = "Clic del mouse ti mette a:";
        document.getElementById("cond").innerHTML = "È possibile utilizzare questo panorama liberamente per fini privati. L'uso commerciale senza il mio consenso scritto non è permesso.<br />Eventuali responsabilità per danni subito utilizzando questo panorama sono esclusi.";
        document.getElementById("aleGE").innerHTML = "Vai alla finestra di Google Earth";
      }
    }
    getStatus();
  }

  function getStatus() {
    try {
      var parts = $get("signature").value.split("|||");
      if (!parts) {
        if (n++ < nmax) hCheckingTimer = setTimeout(getStatus, 1000);
        return false;
      }
      signature = parts[0];
      //$get("help").innerHTML = helpTxt; //helpTxt defined?
       
      if (XMLHTTPObj) {
        if (XMLHTTPObj.readyState) XMLHTTPObj.abort();
        XMLHTTPObj.onreadystatechange = showStatus;
        XMLHTTPObj.open("GET", "panqueryfullact.aspx?act=getstatus&sig=" + signature + "&lg=" + lg, true);
        //XMLHTTPObj.overrideMimeType("text/html; charset=ISO-8859-1");
        XMLHTTPObj.setRequestHeader("Cache-Control", "no-cache, no-store");
        XMLHTTPObj.send(null)
      }
    }
    catch (ex) {
      if (n++ < nmax) hCheckingTimer = setTimeout(getStatus, 1000);
      return;
    }
  }

  function showStatus() {
    try {
      //alert("11a: " + XMLHTTPObj.readyState);
      if (XMLHTTPObj.readyState != 4) return;
      //alert("11b: " + XMLHTTPObj.status);
      if (XMLHTTPObj.status != 200) return;
      //alert(12);
      var parts = XMLHTTPObj.responseText.split("|");
      //alert(parts);
      if (parts && parts[0].substr(0, 8) != "NoResult") {
        if (parts[0] == "Ok") {
          $get("msg").style.display = "none";
          n = 0;
          hCheckingTimer = setTimeout(checkFinishedPans, 1000);
          return;
        } else {
          $get("msg").innerHTML = parts[0];
          if (parts[0].toLowerCase().indexof("Identi") >= 0) {
            $get("loadingMessage").innerHTML = "";
            return;
          } else {
            n = 0;
            if (n++ < nmax) hCheckingTimer = setTimeout(getStatus, 1000);
            return;
          }
        }
      } else {
        if (n++ < nmax) hCheckingTimer = setTimeout(getStatus, 1000);
        return;
      }
    }
    catch (ex) {
      if (n++ < nmax) hCheckingTimer = setTimeout(getStatus, 1000);
      return;
    }
  }

  function checkFinishedPans() {
    try {
        var parts = $get("signature").value.split("|||");
        if (!parts) {
            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return false;
        }
        signature = parts[0];
        nrImages = parts[1];
        if (parts[2] == "True") colorCoding = true; else colorCoding = false;
        if (!signature || !nrImages || nrImages == 0) {
            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return false;
        }

        if (!imgTagsSet) {
          $get("pic").style.width = (nrImages * imgWidth + 50) + "px";
            for (var k = 1; k <= nrImages; k++) {
                $get("pic").innerHTML += "<img id='img" + k + "' />";
                //$get("img" + k).style.width = (imgWidth + "px");
                $get("img" + k).style.height = "750px";
                $get("img" + k).style.visibility = "hidden";
            }
            if (colorCoding) {
                $get("pic").innerHTML += "<img id='imgcol' />";
                $get("imgcol").style.display = "none";
            }
            imgTagsSet = true;
          }

        if (Number(nrImagesRetrieved) < nrImages) {
            getImages(Number(nrImagesRetrieved) + 1);
        } else {
            if ((colorCoding == true) && (Number(nrColScalesRetrieved) == 0)) {
                getColorScale();
            } else {
                if (nrLabelimagesRetrieved == 0) {
                    getLabels();
                } else {
                    if (nrScriptsRetrieved == 0) {
                        getScripts();
                    } else {
                        getFinish();
                    }
                }
            }
        }    
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
    }    
}

function getImages(nr) {
    try {
        if (XMLHTTPObj) {
            //alert(filter + ", " + mode + ", " + XMLHTTPObj.readyState + ", " + (XMLHTTPObj.status));
            if (XMLHTTPObj.readyState) XMLHTTPObj.abort();
            XMLHTTPObj.onreadystatechange = showImages;
            XMLHTTPObj.open("GET", "panqueryfullact.aspx?act=getimg&nr=" + nr + "&sig=" + signature, true);
            //XMLHTTPObj.overrideMimeType("text/html; charset=ISO-8859-1");
            XMLHTTPObj.setRequestHeader("Cache-Control", "no-cache, no-store");
            XMLHTTPObj.send(null)
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

function showImages() {
    var k;
    try {
        if (XMLHTTPObj.readyState != 4) return;
        //alert("11b: " + XMLHTTPObj.status);
        if (XMLHTTPObj.status != 200) return;
        //alert(12);
        var parts = XMLHTTPObj.responseText.split("|");
        //alert(parts);
        if (parts && parts[0].length > 0 && parts[1] && Number(parts[1]) > 0) {

            var parts1 = parts[0].split("&");
            for (k = 0; k < parts1.length; k++) {
                var parts2 = parts1[k].split("$");
                img = $get("img" + parts2[0]);
                img.src = "https://" + server + "/panoramas/pans/" + parts2[1] + ".png";
                img.alt = "";
                img.style.visibility = "visible";
            }
            nrImagesRetrieved = Number(parts[1]);
            if (lg == "en") {
              $get("loadingStatus").innerHTML = (Math.round(nrImagesRetrieved / nrImages * 100)) + "%<br />Calculating panorama";
              if (nrImagesRetrieved / nrImages > 0.9999) {
                $get("loadingStatus").innerHTML = "<br />Loading labels";
                if (nrImages > 100) $get("loadingStatus").innerHTML += ".<br /><span style='font:6pt'>This may take a couple of minutes.</span>";
              }
            } else {
              if (lg == "it") {
                $get("loadingStatus").innerHTML = (Math.round(nrImagesRetrieved / nrImages * 100)) + "%<br />Calcolo panorama";
                if (nrImagesRetrieved / nrImages > 0.9999) {
                  $get("loadingStatus").innerHTML = "<br />Caricamento etichette";
                  if (nrImages > 100) $get("loadingStatus").innerHTML += ".<br /><span style='font:6pt'>Questa operazione potrebbe richiedere un paio di minuti.</span>";
                }
              } else {
                $get("loadingStatus").innerHTML = (Math.round(nrImagesRetrieved / nrImages * 100)) + "%<br />Panorama berechnen";
                if (nrImagesRetrieved / nrImages > 0.9999) {
                  $get("loadingStatus").innerHTML = "<br />Labels laden";
                  if (nrImages > 100) $get("loadingStatus").innerHTML += ".<br /><span style='font:6pt'>Das kann einige Minuten dauern.</span>";
                }
              }
            }
            if (Number(nrImagesRetrieved) == nrImages) {
                for (k = 1; k <= nrImages; k++) {
                    img = $get("img" + k);
                    if (img.width < 10 || img.style.visibility != "visible") {
                        h = k.toString();
                        while (h.length < 4) h = "0" + h;
                        h = signature + "_" + h;
                        img.src = "https://" + server + "/panoramas/pans/" + h + ".png";
                    }
                }
            }
            n = 0;
            hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        } else {
            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

function getColorScale() {
    try {
        if (XMLHTTPObj) {
            if (XMLHTTPObj.readyState) XMLHTTPObj.abort();
            XMLHTTPObj.onreadystatechange = showColorScale;
            XMLHTTPObj.open("GET", "panqueryfullact.aspx?act=getcol&sig=" + signature, true);
            //XMLHTTPObj.overrideMimeType("text/html; charset=ISO-8859-1");
            XMLHTTPObj.setRequestHeader("Cache-Control", "no-cache, no-store");
            XMLHTTPObj.send(null)
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

function showColorScale() {
    try {
        if (XMLHTTPObj.readyState != 4) return;
        if (XMLHTTPObj.status != 200) return;
        var parts = XMLHTTPObj.responseText.split("|");
        if (parts && parts[0] != "NoResult") {
            img = $get("imgcol");
            img.src = "https://" + server + "/panoramas/pans/" + parts[0] + ".png";
            img.alt = "";
            img.style.display = "inline";
            nrColScalesRetrieved++;
            n = 0;
            hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        } else {
            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

function getLabels() {
    try {
        if (XMLHTTPObj) {
            if (XMLHTTPObj.readyState) XMLHTTPObj.abort();
            XMLHTTPObj.onreadystatechange = showLabels;
            XMLHTTPObj.open("GET", "panqueryfullact.aspx?act=getlabels&sig=" + signature, true);
            //XMLHTTPObj.overrideMimeType("text/html; charset=ISO-8859-1");
            XMLHTTPObj.setRequestHeader("Cache-Control", "no-cache, no-store");
            XMLHTTPObj.send(null)
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

function showLabels() {
    try {
        if (XMLHTTPObj.readyState != 4) return;
        if (XMLHTTPObj.status != 200) return;
        var parts = XMLHTTPObj.responseText.split("|");
        if (parts && parts[0] != "NoResult") {
            img = $get("imglabels");
            img.src = "https://" + server + "/panoramas/pans/" + parts[0] + ".png";
            img.alt = "";
            img.style.display = "inline";
            nrLabelimagesRetrieved++;
            if (lg == "en") {
              $get("loadingStatus").innerHTML = "<br />Loading data";
            } else {
              if (lg == "it") {
                $get("loadingStatus").innerHTML = "<br />Caricamento dei dati";
              } else {
                $get("loadingStatus").innerHTML = "<br />Daten laden";
              }
            }
            n = 0;
            hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        } else {
            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

function getScripts() {
    try {
        if (XMLHTTPObj) {
            if (XMLHTTPObj.readyState) XMLHTTPObj.abort();
            XMLHTTPObj.onreadystatechange = showScripts;
            XMLHTTPObj.open("GET", "panqueryfullact.aspx?act=getscripts&sig=" + signature, true);
            //XMLHTTPObj.overrideMimeType("text/html; charset=ISO-8859-1");
            XMLHTTPObj.setRequestHeader("Cache-Control", "no-cache, no-store");
            XMLHTTPObj.send(null)
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

function showScripts() {
    try {
        if (XMLHTTPObj.readyState != 4) return;
        if (XMLHTTPObj.status != 200) return;
        var parts = XMLHTTPObj.responseText.split("|", 2);
        if (parts && parts[0] != "NoResult") {
            var head = document.getElementsByTagName("head")[0];
            var script = document.createElement("script");
            script.setAttribute("type", "text/javascript");
            script.setAttribute("src", "https://" + server + "/panoramas/pans/" + parts[0] + ".js");
            head.appendChild(script);
            nrScriptsRetrieved++;
            if (lg == "en") {
              $get("loadingStatus").innerHTML = "<br />Calculating data";
            } else {
              if (lg == "it") {
                $get("loadingStatus").innerHTML = "<br />Calcolo dei dati";
              } else {
                $get("loadingStatus").innerHTML = "<br />Daten berechnen";
              }
            }
            n = 0;
            hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        } else {
            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }
}

function getFinish() {
    try {
        if (XMLHTTPObj) {
            if (XMLHTTPObj.readyState) XMLHTTPObj.abort();
            XMLHTTPObj.onreadystatechange = showFinish;
            XMLHTTPObj.open("GET", "panqueryfullact.aspx?act=getfinish&sig=" + signature, true);
            //XMLHTTPObj.overrideMimeType("text/html; charset=ISO-8859-1");
            XMLHTTPObj.setRequestHeader("Cache-Control", "no-cache, no-store");
            XMLHTTPObj.send(null)
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }    
}

//-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
//function showFinish() {
//    try {
//        if (XMLHTTPObj.readyState != 4) return;
//        if (XMLHTTPObj.status != 200) return;
//        var parts = XMLHTTPObj.responseText.split("|");
//        //alert(parts);
//        if (parts && parts[0] != "NoResult") {
//            $get("divMessage").innerHTML = parts[1];
//            if (parts[2] && !isNaN(parts[2])) {
//                document.getElementById("newColCodeLimit").value = parts[2];
//                parent.document.getElementById("newColCodeLimit").value = document.getElementById("newColCodeLimit").value;
//            }
//            clearTimeout(hCheckingTimer);
//        } else {
//            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
//            return;
//        }
//    }
//    catch (ex) {
//        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
//        return;
//    }
//}

//-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

function showFinish() {
    try {
        if (XMLHTTPObj.readyState != 4) return;
        if (XMLHTTPObj.status != 200) return;
        var parts = XMLHTTPObj.responseText.split("|");
        if (parts && parts[0] != "NoResult") {
//            if (!parts[2] || parts[2].length == 0) {
//                setTimeout("PageMethods.GetComplete(signature, OnSucceededComplete, OnFailedComplete)", 1000);
//                return false;
//            }
            clearTimeout(hCheckingTimer);
            if (parts[1].length > 0) {
              $get("msg").innerHTML = parts[1];
              $get("msg").style.display = "inline";
            } else {
                $get("msg").style.display = "none";
            }
            $get("lat").innerHTML = parts[3];
            $get("lon").innerHTML = parts[4];
            $get("alt").innerHTML = parts[5];
            $get("zoom").innerHTML = parts[6];
            $get("tilt").innerHTML = parts[7];
        } else {
            if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
            return;
        }
    }
    catch (ex) {
        if (n++ < nmax) hCheckingTimer = setTimeout(checkFinishedPans, 1000);
        return;
    }
}

function getXMLHTTP() {
    try {
        return new ActiveXObject("Msxml2.XMLHTTP")
    } catch (e1) {
        try {
            return new ActiveXObject("Microsoft.XMLHTTP")
        } catch (e2) {
            return typeof XMLHttpRequest != "undefined" ?
          new XMLHttpRequest() : null;
        }
    }
}

function finish() {
    //alert("Window is closing");
    var text;
    if (lg == "en") {
        text = "Cancelled";
    } else {
        if (lg == "it") {
            text = "Cancellato";
        } else {
            text = "Abgebrochen";
        }
    }
    $get("loadingCancel").innerHTML = text;
    if (XMLHTTPObj) {
        XMLHTTPObj.open("GET", "panqueryfullact.aspx?act=close&sig=" + signature, true);
        XMLHTTPObj.setRequestHeader("Cache-Control", "no-cache, no-store");
        XMLHTTPObj.send(null)
    }
    clearTimeout(hCheckingTimer);
}


